unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Spin, WndWrapper;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormChangeBounds(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
  private
    fWndWrapper : TWndWrapper;
    fInsert :Boolean;
    procedure PlaceWindow;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

// Variablen initialisieren
procedure TForm1.FormCreate(Sender: TObject);
begin
  // Ändern der Caption, damit nicht das Design-Fenster des Formular eine anderen
  // Titel hat.
  Form1.Caption := 'PW_Test';
  fInsert := False;
end;

// OnActivate nur einmal ausführen und dabei die Fensterliste erzeugen.
// Die Fensterliste darf erst hier erstellt werden, wenn FormCreate bereits
// erledigt ist.
procedure TForm1.FormActivate(Sender: TObject);
begin
  Form1.OnActivate := nil;
  fWndWrapper := TWndWrapper.Create(Form1.Caption);
end;

procedure TForm1.FormChangeBounds(Sender: TObject);
begin
  PlaceWindow;
end;

// Fensterliste im Memo anzeigen.
procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Assign(fWndWrapper.WindowList);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  fWndWrapper.MoveWndTo(fWndWrapper.SelectWindow(Edit1.Text), SpinEdit1.Value, SpinEdit2.Value);
end;

// Funktioniert nicht.
procedure TForm1.Button3Click(Sender: TObject);
begin
  fWndWrapper.MakeMainParent(fWndWrapper.SelectWindow(Edit1.Text), SpinEdit1.Value, SpinEdit2.Value);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  fWndWrapper.HideDecorations(fWndWrapper.SelectWindow(Edit1.Text));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  fWndWrapper.BringToFront(fWndWrapper.SelectWindow(Edit1.Text));
end;

procedure TForm1.Button6Click(Sender: TObject);
Var
  pnt : TPoint;
begin
  pnt := fWndWrapper.GetAbsCoord(fWndWrapper.SelectWindow(Edit1.Text));
  // Koordinaten des gewünschten Fensters in Memo schreiben.
  Memo1.Lines.Add('X: '+IntToStr(pnt.X)+' Y: '+IntTostr(pnt.Y));
end;

// "Fügt" ein Fremdfenster dauerhaft auf das Panel ein
procedure TForm1.Button7Click(Sender: TObject);
begin
  // Fensterdekoration entfernen.
  fWndWrapper.HideDecorations(fWndWrapper.SelectWindow(Edit1.Text));
  fInsert := True;
  PlaceWindow;
end;

// Minimiert ein Fenster
procedure TForm1.Button8Click(Sender: TObject);
begin
  fWndWrapper.Minimize(fWndWrapper.SelectWindow(Edit1.Text));
end;

// Zeigt ein Fenster wieder normal an.
procedure TForm1.Button9Click(Sender: TObject);
begin
  fWndWrapper.Normal(fWndWrapper.SelectWindow(Edit1.Text));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  fWndWrapper.Free;
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin
  PlaceWindow;
end;

// Alle Funktionen um ein Fremdfenster auf einem Panel zu platzieren und auf
// Größenänderungen oder Verschieben zu reagieren.
procedure TForm1.PlaceWindow;
Var
  Trgt, Src : TPoint;
  Wnd : Cardinal;
begin
  if fInsert then
  begin
    Src.Create(Panel2.Left, Panel2.Top);
    Trgt := fWndWrapper.GetAbsMainCoord(Src);
    Wnd := fWndWrapper.SelectWindow(Edit1.Text);
    fWndWrapper.MoveWndTo(Wnd, Trgt.X, Trgt.Y);
    fWndWrapper.ResizeWindow(Wnd,Panel2.Width,Panel2.Height);
    fWndWrapper.BringToFront(Wnd);
  end;
end;


end.

